src/AppBundle/Controller/AbstractController.php
<?php

/*
 * This file is part of the Arnapou GW2Tools package.
 *
 * (c) Arnaud Buathier <arnaud@arnapou.net>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace AppBundle\Controller;

use AppBundle\Entity\Token;
use AppBundle\Repository\TokenRepository;
use Arnapou\GW2Api\Exception\ApiUnavailableException;
use Arnapou\GW2Api\Exception\InvalidTokenException;
use Arnapou\GW2Api\Exception\MissingPermissionException;
use Gw2tool\Account;
use Gw2tool\Gw2ApiEnvironmentTrait;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Translation\Translator;

abstract class AbstractController extends Controller
{
    use Gw2ApiEnvironmentTrait;

    /**
     *
     * @var array
     */
    private $cookieUsers = null;

    /**
     *
     * @return Request
     */
    public function getRequest()
    {
        return $this->container->get('request_stack')->getCurrentRequest();
    }

    /**
     *
     * @param Token $token
     * @return bool
     */
    protected function isTokenOwner(Token $token)
    {
        foreach ($this->getCookieTokens() as $value) {
            if ($token->getToken() == $value) {
                return true;
            }
        }
        return false;
    }

    /**
     *
     * @param string $token
     * @return Account
     */
    protected function getAccount($token)
    {
        $env = $this->getGwEnvironment()->setAccessToken((string)$token);
        return new Account($env);
    }

    /**
     *
     * @param Account $account
     * @return array
     */
    protected function getCharacters(Account $account)
    {
        $characters = [];
        foreach ($account->getCharacters() as $character) {
            $characters[$character->getName()] = $character;
        }
        ksort($characters);
        return $characters;
    }

    /**
     *
     * @param Account $account
     * @return array
     */
    protected function getGuilds(Account $account)
    {
        $guilds = [];
        foreach ($account->getGuilds(true) as $guild) {
            $guilds[$guild->getId()] = $guild;
        }
        return $guilds;
    }

    /**
     *
     * @param Token $token
     * @param null  $exception
     * @return bool
     * @throws ApiUnavailableException
     */
    public function checkToken(Token $token, &$exception = null)
    {
        try {
            $account = $this->getAccount($token);
            $token->setName($account->getName());
            $token->setIsValid(true);
            $token->updateLastaccess();
        } catch (InvalidTokenException $exception) {
            $token->setIsValid(false);
        } catch (MissingPermissionException $exception) {
            $token->setIsValid(false);
        } catch (ApiUnavailableException $exception) {
            return false;
        } catch (\Exception $exception) {
            $token->setIsValid(false);
        }
        $manager = $this->getDoctrine()->getManager();
        $manager->persist($token);
        $manager->flush();
        return $token->isValid();
    }

    public function getConnection()
    {
        return $this->getDoctrine()->getConnection();
    }

    /**
     *
     * @return TokenRepository
     */
    public function getTokenRepository()
    {
        return $this->getDoctrine()->getRepository(Token::class);
    }

    /**
     *
     * @return array
     */
    public function getLangs()
    {
        return $this->getParameter('locales');
    }

    /**
     *
     * @return array
     */
    public function getCookieTokens()
    {
        $cookie = $this->getRequest()->cookies->get('accesstoken');
        if (empty($cookie)) {
            return [];
        }
        return explode('|', $cookie);
    }

    /**
     *
     * @return array
     */
    public function getCookieUsers()
    {
        if ($this->cookieUsers === null) {
            $savedAccessToken = $this->getGwEnvironment()->getAccessToken();
            $items            = [];
            $repo             = $this->getTokenRepository();
            foreach ($this->getCookieTokens() as $token) {
                $object = $repo->findOneByToken($token);
                if ($object && $this->checkToken($object)) {
                    $items[] = $object;
                }
            }
            $this->cookieUsers = $items;
            $this->getGwEnvironment()->setAccessToken($savedAccessToken);
        }
        return $this->cookieUsers;
    }

    /**
     *
     * @return string
     */
    public function getDataPath()
    {
        return $this->get('kernel')->getRootDir() . '/../data';
    }

    protected function render($view, array $parameters = [], Response $response = null)
    {
        $view = $this->getViewPrefix() . $view;
        if (strpos($view, ':') === false) {
            $view = 'AppBundle::' . $view;
        }
        $parameters['lang']   = $this->getTranslator()->getLocale();
        $parameters['module'] = $this;
        return parent::render($view, $parameters, $response);
    }

    /**
     * @return string
     */
    abstract public function getViewPrefix();

    /**
     *
     * @return Translator
     */
    public function getTranslator()
    {
        return $this->get('translator');
    }

    /**
     * Translates the given message.
     *
     * @param string      $id         The message id (may also be an object that can be cast to string)
     * @param array       $parameters An array of parameters for the message
     * @param string|null $domain     The domain for the message or null to use the default
     * @param string|null $locale     The locale or null to use the default
     *
     * @throws \InvalidArgumentException If the locale contains invalid characters
     *
     * @return string The translated string
     */
    public function trans($id, array $parameters = [], $domain = null, $locale = null)
    {
        return $this->get('translator')->trans($id, $parameters, $domain, $locale);
    }

    /**
     * Translates the given choice message by choosing a translation according to a number.
     *
     * @param string      $id         The message id (may also be an object that can be cast to string)
     * @param int         $number     The number to use to find the indice of the message
     * @param array       $parameters An array of parameters for the message
     * @param string|null $domain     The domain for the message or null to use the default
     * @param string|null $locale     The locale or null to use the default
     *
     * @throws \InvalidArgumentException If the locale contains invalid characters
     *
     * @return string The translated string
     */
    public function transChoice($id, $number, array $parameters = [], $domain = null, $locale = null)
    {
        return $this->getTranslator()->transChoice($id, $number, $parameters, $domain, $locale);
    }

    /**
     *
     * @return string
     */
    public function getEnv()
    {
        return $this->get('kernel')->getEnvironment();
    }
}

src/AppBundle/Resources/views/base/footer.html.twig
{% spaceless %}
    <div class="row">
        <div class="col-xs-6">
            <ul>
                <li>
                    <i class="glyphicon glyphicon-user"></i> {{ "footer.site_development"|trans }}:
                    <a href="mailto:arnaud@arnapou.net">Arnaud Buathier</a>
                </li>
                <li>
                    <img src="{{ asset('assets/images/misc/github.png') }}"/> GitHub:
                    <a href="https://github.com/arnapou/gw2tools"
                       target="_blank">{{ "footer.gw2tools_project"|trans }}</a>&nbsp;
                    <em>(v{{ asset_version('') }})</em>
                </li>
                <li>
                    <i class="glyphicon glyphicon-list-alt"></i> {{ "footer.changelog"|trans }}:
                    <a href="https://github.com/arnapou/gw2tools/blob/master/CHANGELOG.md"
                       target="_blank">{{ "footer.project_changelog"|trans }}</a>
                </li>
                <li>
                    <i class="glyphicon glyphicon-wrench"></i> {{ "footer.technical"|trans }}:
                    <a href="{{ path('technical-infos') }}">{{ "footer.for_developers"|trans }}</a>
                </li>
                <li>
                    <i class="glyphicon glyphicon-globe"></i> {{ "footer.languages"|trans }}:
                    {% for lang in module.langs %}
                        {% if not loop.first %}
                            <span>, </span>
                        {% endif %}
                        <a href="/{{ lang }}{{ app.request.pathinfo|slice(3) }}">{{ lang|upper }}</a>
                    {% endfor %}
                </li>
            </ul>
        </div>
        <div class="col-xs-6">
            <div class="logo">
                <a href="http://guildwars2.com/" target="_blank">
                    <img src="/assets/images/logo/gw2.png" width="128"/>
                </a>
                <a href="http://www.arena.net/" target="_blank">
                    <img src="/assets/images/logo/anet.png" width="128"/>
                </a>
                <a href="http://us.ncsoft.com/" target="_blank">
                    <img src="/assets/images/logo/ncsoft.png" width="128"/>
                </a>
            </div>
            <p>
                &copy; {{ "footer.anet_copyright"|trans }}
            </p>
        </div>
    </div>
{% endspaceless %}

src/AppBundle/Resources/views/base/menu-left.html.twig
{% spaceless %}
    {% if code %}

        <ul class="nav navbar-nav">
            {% for list in module.menu %}
                {% set items = list.items(owner ? none : user) %}
                {% if items|length %}
                    <li class="dropdown">
                        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button"
                           aria-haspopup="true" aria-expanded="false">
                            {{ list.label }} <span class="caret"></span>
                        </a>
                        <ul class="dropdown-menu scrollable-menu">
                            {% for item in items %}
                                {% if item.separator %}
                                    <li role="separator" class="divider">
                                    </li>
                                {% else %}
                                    <li>
                                        {% if item.permission is none or item.permission and account.haspermission(item.permission) %}
                                            <a href="../{{ item.uri }}">
                                                <i class="menuicon {{ item.icon }}"></i> {{ item.label }}
                                            </a>
                                        {% else %}
                                            <a href="../{{ item.uri }}" class="locked">
                                                <i class="menuicon glyphicon glyphicon-lock"></i> {{ item.label }}
                                            </a>
                                        {% endif %}
                                    </li>
                                {% endif %}
                            {% endfor %}
                        </ul>
                    </li>
                {% endif %}
            {% endfor %}
        </ul>

    {% endif %}
{% endspaceless %}

src/AppBundle/Resources/views/base/menu-right.html.twig
{% spaceless %}
    {% set users = module.cookieusers %}

    <ul class="nav navbar-nav navbar-right">
        <li class="dropdown">
            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true"
               aria-expanded="false">
                {{ ('menu.tools'|trans) }} <span class="caret"></span>
            </a>
            <ul class="dropdown-menu scrollable-menu">
                {% if account and (users|length) %}
                    {% for usr in users %}
                        {% if account.name == usr.name %}
                            <li>
                                <a href="/{{ lang }}/{{ usr.code }}/raidplanner/">
                                    {{ 'raidplanner'|trans }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                {% endif %}
                {% for str in [
                'chatcode',
                'api_itemstats',
                'api_pets',
                'api_files',
                'api_quaggans',
                'api_minis',
                'api_gliders',
                'api_outfits',
                'api_mailcarriers',
                'api_titles',
                'api_specializations',
                'api_professionskills',
                ] %}
                    <li>
                        <a href="/{{ lang }}/tools/{{ str }}/">{{ ('tools.'~str)|trans }}</a>
                    </li>
                {% endfor %}
            </ul>
        </li>

        {% if account or (users|length) %}
            {% if users|length %}
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true"
                       aria-expanded="false">
                        {{ account.name ? account.name : ('menu.accounts'|trans) }} <span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu scrollable-menu">
                        {% for usr in users %}
                            <li>
                                <a href="/{{ lang }}/{{ usr.code }}/" class="account-link">
                                    <small> ... {{ usr.token|slice(-4) }}</small>
                                    {{ usr.name ? usr.name : '??????' }}
                                </a>
                            </li>
                        {% endfor %}
                    </ul>
                </li>
            {% elseif account %}
                <li>
                    <p class="navbar-text"><b>{{ account.name }}</b></p>
                </li>
            {% endif %}
        {% endif %}
    </ul>

{% endspaceless %}

src/AppBundle/Resources/views/base/tracking.html.twig
{% spaceless %}
    {% if tracking_piwik_url and tracking_piwik_id %}

        <script type="text/javascript">
            var _paq = _paq || [];
            /* tracker methods like "setCustomDimension" should be called before "trackPageView" */
            _paq.push(['trackPageView']);
            _paq.push(['enableLinkTracking']);
            (function () {
                var u ={{ tracking_piwik_url|json_encode|raw }};
                _paq.push(['setTrackerUrl', u + 'piwik.php']);
                _paq.push(['setSiteId', {{ tracking_piwik_id|json_encode|raw }}]);
                var d = document, g = d.createElement('script'), s = d.getElementsByTagName('script')[0];
                g.type = 'text/javascript';
                g.async = true;
                g.defer = true;
                g.src = u + 'piwik.js';
                s.parentNode.insertBefore(g, s);
            })();
        </script>

    {% endif %}
{% endspaceless %}